/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.120
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.62 2004/07/15 04:59:44 lv Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.120 2007/07/22 08:21:09 dberkholz Exp $
4# 4#
5# Author Bart Verwilst <verwilst@gentoo.org> 5# Maintainer: toolchain@gentoo.org
6 6
7ECLASS=flag-o-matic 7# need access to emktemp()
8INHERITED="$INHERITED $ECLASS" 8inherit eutils toolchain-funcs multilib
9IUSE="$IUSE debug"
10 9
11# 10#
12#### filter-flags <flags> #### 11#### filter-flags <flags> ####
13# Remove particular flags from C[XX]FLAGS 12# Remove particular flags from C[XX]FLAGS
14# Matches only complete flags 13# Matches only complete flags
17# Add extra flags to your current C[XX]FLAGS 16# Add extra flags to your current C[XX]FLAGS
18# 17#
19#### replace-flags <orig.flag> <new.flag> ### 18#### replace-flags <orig.flag> <new.flag> ###
20# Replace a flag by another one 19# Replace a flag by another one
21# 20#
22#### replace-cpu-flags <new.cpu> <old.cpus> ### 21#### replace-cpu-flags <old.cpus> <new.cpu> ###
23# Replace march/mcpu flags that specify <old.cpus> 22# Replace march/mcpu flags that specify <old.cpus>
24# with flags that specify <new.cpu> 23# with flags that specify <new.cpu>
25# 24#
26#### is-flag <flag> #### 25#### is-flag[q] <flag> ####
27# Returns "true" if flag is set in C[XX]FLAGS 26# Returns "true" if flag is set in C[XX]FLAGS
28# Matches only complete a flag 27# Matches only complete a flag
28# q version sets return code but doesn't echo
29#
30#### is-ldflag[q] <flag> ####
31# Returns "true" if flag is set in LDFLAGS
32# Matches only complete a flag
33# q version sets return code but doesn't echo
29# 34#
30#### strip-flags #### 35#### strip-flags ####
31# Strip C[XX]FLAGS of everything except known 36# Strip C[XX]FLAGS of everything except known
32# good options. 37# good options.
33# 38#
52# 57#
53#### filter-ldflags <flags> #### 58#### filter-ldflags <flags> ####
54# Remove particular flags from LDFLAGS 59# Remove particular flags from LDFLAGS
55# Matches only complete flags 60# Matches only complete flags
56# 61#
57#### etexec-flags #### 62#### bindnow-flags ####
58# hooked function for hardened gcc that appends 63# Returns the flags to enable "now" binding in the current selected linker.
59# -fno-pic to {C,CXX,LD}FLAGS
60# when a package is filtering -fpic, -fPIC, -fpie, -fPIE
61# 64#
62#### fstack-flags #### 65################ DEPRECATED functions ################
63# hooked function for hardened gcc that appends 66# The following are still present to avoid breaking existing
64# -fno-stack-protector to {C,CXX,LD}FLAGS 67# code more than necessary; however they are deprecated. Please
65# when a package is filtering -fstack-protector, -fstack-protector-all 68# use gcc-specs-* from toolchain-funcs.eclass instead, if you
66# notice: modern automatic specs files will also suppress -fstack-protector-all 69# need to know which hardened techs are active in the compiler.
67# when only -fno-stack-protector is given 70# See bug #100974
71#
72#### has_hardened ####
73# Returns true if the compiler has 'Hardened' in its version string,
74# (note; switched-spec vanilla compilers satisfy this condition) or
75# the specs file name contains 'hardened'.
76#
77#### has_pie ####
78# Returns true if the compiler by default or with current CFLAGS
79# builds position-independent code.
80#
81#### has_pic ####
82# Returns true if the compiler by default or with current CFLAGS
83# builds position-independent code.
84#
85#### has_ssp_all ####
86# Returns true if the compiler by default or with current CFLAGS
87# generates stack smash protections for all functions
88#
89#### has_ssp ####
90# Returns true if the compiler by default or with current CFLAGS
91# generates stack smash protections for most vulnerable functions
68# 92#
69 93
70# C[XX]FLAGS that we allow in strip-flags 94# C[XX]FLAGS that we allow in strip-flags
95# Note: shell globs and character lists are allowed
71setup-allowed-flags() { 96setup-allowed-flags() {
72 if [ -z "${ALLOWED_FLAGS}" ] ; then 97 if [[ -z ${ALLOWED_FLAGS} ]] ; then
73 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -fno-unit-at-a-time -pipe -g" 98 export ALLOWED_FLAGS="-pipe"
74 case "${ARCH}" in 99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
75 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
76 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC -m64" ;; 101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking"
102 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
103 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
104 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
77 x86) ALLOWED_FLAGS="${ALLOWED_FLAGS} -m32" ;; 105 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
78 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;;
79 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;;
80 esac
81 fi 106 fi
107 # allow a bunch of flags that negate features / control ABI
108 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
109 -fno-strict-aliasing -fno-bounds-checking"
110 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
111 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
112 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
113 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
114 -mieee -mieee-with-inexact -mschedule \
115 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
116 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
117 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
118 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
119 -msecure-plt -D*"
82 120
83 # C[XX]FLAGS that we are think is ok, but needs testing 121 # C[XX]FLAGS that we are think is ok, but needs testing
84 # NOTE: currently -Os have issues with gcc3 and K6* arch's 122 # NOTE: currently -Os have issues with gcc3 and K6* arch's
85 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 123 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
86 return 0 124 return 0
125}
126
127# inverted filters for hardened compiler. This is trying to unpick
128# the hardened compiler defaults.
129_filter-hardened() {
130 local f
131 for f in "$@" ; do
132 case "${f}" in
133 # Ideally we should only concern ourselves with PIE flags,
134 # not -fPIC or -fpic, but too many places filter -fPIC without
135 # thinking about -fPIE.
136 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
137 gcc-specs-pie || continue
138 is-flagq -nopie || append-flags -nopie;;
139 -fstack-protector)
140 gcc-specs-ssp || continue
141 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
142 -fstack-protector-all)
143 gcc-specs-ssp-to-all || continue
144 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
145 esac
146 done
147}
148
149# Remove occurrences of strings from variable given in $1
150# Strings removed are matched as globs, so for example
151# '-O*' would remove -O1, -O2 etc.
152_filter-var() {
153 local f x VAR VAL
154 declare -a new
155
156 VAR=$1
157 shift
158 eval VAL=\${${VAR}}
159 for f in ${VAL}; do
160 for x in "$@"; do
161 # Note this should work with globs like -O*
162 [[ ${f} == ${x} ]] && continue 2
163 done
164 eval new\[\${\#new\[@]}]=\${f}
165 done
166 eval export ${VAR}=\${new\[*]}
87} 167}
88 168
89filter-flags() { 169filter-flags() {
90 local x f fset 170 _filter-hardened "$@"
91 declare -a new_CFLAGS new_CXXFLAGS 171 _filter-var CFLAGS "$@"
92 172 _filter-var CPPFLAGS "$@"
93 for x in "$@" ; do 173 _filter-var CXXFLAGS "$@"
94 case "${x}" in
95 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;;
96 -fstack-protector|-fstack-protector-all) fstack-flags;;
97 esac
98 done
99
100 for fset in CFLAGS CXXFLAGS; do
101 for f in ${!fset}; do
102 for x in "$@"; do
103 # Note this should work with globs like -O*
104 [[ ${f} == ${x} ]] && continue 2
105 done
106 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
107 done
108 eval export ${fset}=\${new_${fset}\[*]}
109 done
110
111 return 0 174 return 0
112} 175}
113 176
114filter-lfs-flags() { 177filter-lfs-flags() {
178 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
115 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 179 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
116} 180}
117 181
182append-cppflags() {
183 [[ -z $* ]] && return 0
184 export CPPFLAGS="${CPPFLAGS} $*"
185 return 0
186}
187
118append-lfs-flags() { 188append-lfs-flags() {
189 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
119 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 190 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
120} 191}
121 192
122append-flags() { 193append-flags() {
194 [[ -z $* ]] && return 0
123 export CFLAGS="${CFLAGS} $*" 195 export CFLAGS="${CFLAGS} $*"
124 export CXXFLAGS="${CXXFLAGS} $*" 196 export CXXFLAGS="${CXXFLAGS} $*"
125 [ -n "`is-flag -fno-stack-protector`" -o \
126 -n "`is-flag -fno-stack-protector-all`" ] && fstack-flags
127 return 0 197 return 0
128} 198}
129 199
130replace-flags() { 200replace-flags() {
131 # we do this fancy spacing stuff so as to not filter 201 [[ $# != 2 ]] \
132 # out part of a flag ... we want flag atoms ! :D 202 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
133 CFLAGS=" ${CFLAGS} " 203 && die "replace-flags takes 2 arguments, not $#"
134 CXXFLAGS=" ${CXXFLAGS} " 204
135 CFLAGS="${CFLAGS// ${1} / ${2} }" 205 local f fset
136 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }" 206 declare -a new_CFLAGS new_CXXFLAGS
137 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}" 207
138 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}" 208 for fset in CFLAGS CXXFLAGS; do
139 export CFLAGS CXXFLAGS 209 # Looping over the flags instead of using a global
210 # substitution ensures that we're working with flag atoms.
211 # Otherwise globs like -O* have the potential to wipe out the
212 # list of flags.
213 for f in ${!fset}; do
214 # Note this should work with globs like -O*
215 [[ ${f} == ${1} ]] && f=${2}
216 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
217 done
218 eval export ${fset}=\${new_${fset}\[*]}
219 done
220
140 return 0 221 return 0
141} 222}
142 223
143replace-cpu-flags() { 224replace-cpu-flags() {
144 local oldcpu newcpu="$1" ; shift 225 local newcpu="$#" ; newcpu="${!newcpu}"
145 for oldcpu in "$@" ; do 226 while [ $# -gt 1 ] ; do
227 # quote to make sure that no globbing is done (particularly on
228 # ${oldcpu}) prior to calling replace-flags
146 replace-flags -march=${oldcpu} -march=${newcpu} 229 replace-flags "-march=${1}" "-march=${newcpu}"
147 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 230 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
148 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 231 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
232 shift
149 done 233 done
234 return 0
235}
236
237_is_flagq() {
238 local x
239 for x in ${!1} ; do
240 [[ ${x} == $2 ]] && return 0
241 done
150 return 0 242 return 1
243}
244
245is-flagq() {
246 [[ -n $2 ]] && die "Usage: is-flag <flag>"
247 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
151} 248}
152 249
153is-flag() { 250is-flag() {
154 local x 251 is-flagq "$@" && echo true
252}
155 253
156 for x in ${CFLAGS} ${CXXFLAGS} ; do 254is-ldflagq() {
157 if [ "${x}" == "$1" ] ; then 255 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
158 echo true 256 _is_flagq LDFLAGS $1
159 return 0 257}
160 fi 258
161 done 259is-ldflag() {
162 return 1 260 is-ldflagq "$@" && echo true
163} 261}
164 262
165filter-mfpmath() { 263filter-mfpmath() {
166 local orig_mfpmath new_math prune_math 264 local orig_mfpmath new_math prune_math
167 265
168 # save the original -mfpmath flag 266 # save the original -mfpmath flag
169 orig_mfpmath="`get-flag -mfpmath`" 267 orig_mfpmath=$(get-flag -mfpmath)
170 # get the value of the current -mfpmath flag 268 # get the value of the current -mfpmath flag
171 new_math=" `get-flag mfpmath | tr , ' '` " 269 new_math=$(get-flag mfpmath)
270 new_math=" ${new_math//,/ } "
172 # figure out which math values are to be removed 271 # figure out which math values are to be removed
173 prune_math="" 272 prune_math=""
174 for prune_math in "$@" ; do 273 for prune_math in "$@" ; do
175 new_math="${new_math/ ${prune_math} / }" 274 new_math=${new_math/ ${prune_math} / }
176 done 275 done
177 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 276 new_math=$(echo ${new_math})
277 new_math=${new_math// /,}
178 278
179 if [ -z "${new_math}" ] ; then 279 if [[ -z ${new_math} ]] ; then
180 # if we're removing all user specified math values are 280 # if we're removing all user specified math values are
181 # slated for removal, then we just filter the flag 281 # slated for removal, then we just filter the flag
182 filter-flags ${orig_mfpmath} 282 filter-flags ${orig_mfpmath}
183 else 283 else
184 # if we only want to filter some of the user specified 284 # if we only want to filter some of the user specified
195 295
196 local NEW_CFLAGS="" 296 local NEW_CFLAGS=""
197 local NEW_CXXFLAGS="" 297 local NEW_CXXFLAGS=""
198 298
199 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 299 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
200 if has ~${ARCH} ${ACCEPT_KEYWORDS} ; then 300 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
201 use debug && einfo "Enabling the use of some unstable flags"
202 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 301 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
203 fi 302 fi
204 303
205 set -f # disable pathname expansion 304 set -f # disable pathname expansion
206 305
207 for x in ${CFLAGS}; do 306 for x in ${CFLAGS}; do
208 for y in ${ALLOWED_FLAGS}; do 307 for y in ${ALLOWED_FLAGS}; do
209 flag=${x%%=*} 308 flag=${x%%=*}
210 if [ "${flag%%${y}}" = "" ]; then 309 if [ "${flag%%${y}}" = "" ] ; then
211 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 310 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
212 break 311 break
213 fi 312 fi
214 done 313 done
215 done 314 done
216 315
217 for x in ${CXXFLAGS}; do 316 for x in ${CXXFLAGS}; do
218 for y in ${ALLOWED_FLAGS}; do 317 for y in ${ALLOWED_FLAGS}; do
219 flag=${x%%=*} 318 flag=${x%%=*}
220 if [ "${flag%%${y}}" = "" ]; then 319 if [ "${flag%%${y}}" = "" ] ; then
221 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 320 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
222 break 321 break
223 fi 322 fi
224 done 323 done
225 done 324 done
237 export CFLAGS="${NEW_CFLAGS}" 336 export CFLAGS="${NEW_CFLAGS}"
238 export CXXFLAGS="${NEW_CXXFLAGS}" 337 export CXXFLAGS="${NEW_CXXFLAGS}"
239 return 0 338 return 0
240} 339}
241 340
341test-flag-PROG() {
342 local comp=$1
343 local flags="$2"
344
345 [[ -z ${comp} || -z ${flags} ]] && \
346 return 1
347
348 local PROG=$(tc-get${comp})
349 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
350 > /dev/null 2>&1
351}
352
353# Returns true if C compiler support given flag
354test-flag-CC() { test-flag-PROG "CC" "$1"; }
355
356# Returns true if C++ compiler support given flag
357test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
358
359test-flags-PROG() {
360 local comp=$1
361 local flags
362 local x
363
364 shift
365
366 [[ -z ${comp} ]] && return 1
367
368 x=""
369 for x in "$@" ; do
370 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
371 done
372
373 echo "${flags}"
374
375 # Just bail if we dont have any flags
376 [[ -n ${flags} ]]
377}
378
379# Returns (echo's) the given flags supported by the C compiler
380test-flags-CC() { test-flags-PROG "CC" "$@"; }
381
382# Returns (echo's) the given flags supported by the C++ compiler
383test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
384
385# Short-hand that should hopefully work for both C and C++ compiler, but
386# its really only present due to the append-flags() abomination.
387test-flags() { test-flags-CC "$@"; }
388
389# Depriciated, use test-flags()
242test_flag() { 390test_flag() {
243 local cc=${CC:-gcc} ; cc=${cc%% *} 391 ewarn "test_flag: deprecated, please use test-flags()!" >&2
244 if ${cc} -S -xc "$@" -o /dev/null /dev/null &>/dev/null; then 392
245 printf "%s\n" "$*" 393 test-flags-CC "$@"
246 return 0
247 fi
248 return 1
249} 394}
250 395
251test_version_info() { 396test_version_info() {
252 local cc=${CC:-gcc} ; cc=${cc%% *}
253 if [[ $(${cc} --version 2>&1) == *$1* ]]; then 397 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
254 return 0 398 return 0
255 else 399 else
256 return 1 400 return 1
257 fi 401 fi
258} 402}
259 403
260strip-unsupported-flags() { 404strip-unsupported-flags() {
261 local NEW_CFLAGS NEW_CXXFLAGS 405 export CFLAGS=$(test-flags-CC ${CFLAGS})
262 406 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
263 for x in ${CFLAGS} ; do
264 NEW_CFLAGS="${NEW_CFLAGS} `test_flag ${x}`"
265 done
266 for x in ${CXXFLAGS} ; do
267 NEW_CXXFLAGS="${NEW_CXXFLAGS} `test_flag ${x}`"
268 done
269
270 export CFLAGS="${NEW_CFLAGS}"
271 export CXXFLAGS="${NEW_CXXFLAGS}"
272} 407}
273 408
274get-flag() { 409get-flag() {
275 local f findflag="$1" 410 local f findflag="$1"
276 411
286 fi 421 fi
287 done 422 done
288 return 1 423 return 1
289} 424}
290 425
426# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
291has_hardened() { 427has_hardened() {
428 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
429
292 test_version_info Hardened 430 test_version_info Hardened && return 0
293 return $? 431 # The specs file wont exist unless gcc has GCC_SPECS support
432 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
294} 433}
295 434
435# DEPRECATED - use gcc-specs-pie from toolchain-funcs
436# indicate whether PIC is set
296has_pic() { 437has_pic() {
297 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 438 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
298 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0
299 test_version_info pie && return 0
300 return 1
301}
302 439
440 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
441 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
442 gcc-specs-pie
443}
444
445# DEPRECATED - use gcc-specs-pie from toolchain-funcs
446# indicate whether PIE is set
303has_pie() { 447has_pie() {
304 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 448 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
305 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 449
306 test_version_info pie && return 0 450 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
307 return 1 451 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
452 gcc-specs-pie
308} 453}
309 454
455# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
456# indicate whether code for SSP is being generated for all functions
457has_ssp_all() {
458 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
459
460 # note; this matches only -fstack-protector-all
461 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
462 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
463 gcc-specs-ssp-all
464}
465
466# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
467# indicate whether code for SSP is being generated
310has_ssp() { 468has_ssp() {
469 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
470
471 # note; this matches both -fstack-protector and -fstack-protector-all
311 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0 472 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
312 test_version_info ssp && return 0 473 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
313 return 1 474 gcc-specs-ssp
314} 475}
315 476
316has_m64() { 477has_m64() {
317 # this doesnt test if the flag is accepted, it tests if the flag 478 # this doesnt test if the flag is accepted, it tests if the flag
318 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 479 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
319 # please dont replace this function with test_flag in some future 480 # please dont replace this function with test_flag in some future
320 # clean-up! 481 # clean-up!
321 temp=`mktemp` 482
483 local temp="$(emktemp)"
322 echo "int main() { return(0); }" > ${temp}.c 484 echo "int main() { return(0); }" > "${temp}".c
323 ${CC/ .*/} -m64 -o /dev/null ${temp}.c > /dev/null 2>&1 485 MY_CC=$(tc-getCC)
324 ret=$? 486 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
487 local ret=$?
325 rm -f ${temp}.c 488 rm -f "${temp}".c
326 [ "$ret" != "1" ] && return 0 489 [[ ${ret} != 1 ]] && return 0
327 return 1 490 return 1
328} 491}
329 492
330has_m32() { 493has_m32() {
331 # this doesnt test if the flag is accepted, it tests if the flag 494 # this doesnt test if the flag is accepted, it tests if the flag
332 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 495 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
333 # please dont replace this function with test_flag in some future 496 # please dont replace this function with test_flag in some future
334 # clean-up! 497 # clean-up!
335 temp=`mktemp` 498
499 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
500
501 local temp=$(emktemp)
336 echo "int main() { return(0); }" > ${temp}.c 502 echo "int main() { return(0); }" > "${temp}".c
337 ${CC/ .*/} -m32 -o /dev/null ${temp}.c > /dev/null 2>&1 503 MY_CC=$(tc-getCC)
338 ret=$? 504 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
505 local ret=$?
339 rm -f ${temp}.c 506 rm -f "${temp}".c
340 [ "$ret" != "1" ] && return 0 507 [[ ${ret} != 1 ]] && return 0
341 return 1 508 return 1
342} 509}
343 510
344replace-sparc64-flags() { 511replace-sparc64-flags() {
345 local SPARC64_CPUS="ultrasparc v9" 512 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
346 513
347 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 514 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
348 for x in ${SPARC64_CPUS}; do 515 for x in ${SPARC64_CPUS}; do
349 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 516 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
350 done 517 done
351 else 518 else
352 for x in ${SPARC64_CPUS}; do 519 for x in ${SPARC64_CPUS}; do
353 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 520 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
354 done 521 done
355 fi 522 fi
356 523
357 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then 524 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
358 for x in ${SPARC64_CPUS}; do 525 for x in ${SPARC64_CPUS}; do
359 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 526 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
360 done 527 done
361 else 528 else
362 for x in ${SPARC64_CPUS}; do 529 for x in ${SPARC64_CPUS}; do
363 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 530 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
364 done 531 done
365 fi 532 fi
366 533
367 export CFLAGS CXXFLAGS 534 export CFLAGS CXXFLAGS
368} 535}
369 536
370append-ldflags() { 537append-ldflags() {
538 [[ -z $* ]] && return 0
371 export LDFLAGS="${LDFLAGS} $*" 539 export LDFLAGS="${LDFLAGS} $*"
372 return 0 540 return 0
373} 541}
374 542
543# Remove flags from LDFLAGS - it's up to the ebuild to filter
544# CFLAGS and CXXFLAGS via filter-flags if they need to.
375filter-ldflags() { 545filter-ldflags() {
376 local x 546 _filter-var LDFLAGS "$@"
547 return 0
548}
377 549
378 # we do this fancy spacing stuff so as to not filter 550# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
379 # out part of a flag ... we want flag atoms ! :D 551# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
380 LDFLAGS=" ${LDFLAGS} " 552# to gcc where it needs the '-Wl,'.
553raw-ldflags() {
554 local x input="$@"
555 [[ -z ${input} ]] && input=${LDFLAGS}
556 set --
381 for x in "$@" ; do 557 for x in ${input} ; do
382 LDFLAGS="${LDFLAGS// ${x} / }" 558 x=${x#-Wl,}
559 set -- "$@" ${x//,/ }
383 done 560 done
384 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 561 echo "$@"
385 export LDFLAGS
386 return 0
387} 562}
388 563
389etexec-flags() { 564# Gets the flags needed for "NOW" binding
390 # if you're not using a hardened compiler you wont need this 565bindnow-flags() {
391 # PIC/no-pic kludge in the first place. 566 case $($(tc-getLD) -v 2>&1 </dev/null) in
392 has_hardened || return 0 567 *GNU* | *'with BFD'*) # GNU ld
393 568 echo "-Wl,-z,now" ;;
394 if has_pie || has_pic; then 569 *Apple*) # Darwin ld
395 [ -z "`is-flag -fno-pic`" ] && 570 echo "-bind_at_load" ;;
396 export CFLAGS="${CFLAGS} `test_flag -fno-pic`" 571 *)
397 [ -z "`is-flag -nopie`" ] && 572 # Some linkers just recognize -V instead of -v
398 export CFLAGS="${CFLAGS} `test_flag -nopie`" 573 case $($(tc-getLD) -V 2>&1 </dev/null) in
399 fi 574 *Solaris*) # Solaris accept almost the same GNU options
400 return 0 575 echo "-Wl,-z,now" ;;
576 esac
577 ;;
578 esac
401} 579}
402 580
403fstack-flags() { 581
404 if has_ssp; then 582# Some tests for when we screw with things and want to make
405 [ -z "`is-flag -fno-stack-protector`" ] && 583# sure we didn't break anything
406 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`" 584#TESTS() {
407 fi 585# CFLAGS="-a -b -c=1"
408 return 0 586# CXXFLAGS="-x -y -z=2"
409} 587# LDFLAGS="-l -m -n=3"
588#
589# die() { exit 1; }
590# (is-flag 1 2 3) && die
591# (is-ldflag 1 2 3) && die
592#
593# is-flagq -l && die
594# is-ldflagq -a && die
595# is-flagq -a || die
596# is-flagq -x || die
597# is-ldflagq -n=* || die
598# is-ldflagq -n && die
599#
600# strip-unsupported-flags
601# [[ ${CFLAGS} == "-c=1" ]] || die
602# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
603#
604# echo "All tests pass"
605#}
606#TESTS

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.120

  ViewVC Help
Powered by ViewVC 1.1.20